// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlThreeGrid")]
    pub struct ThreeGrid(Object<ffi::DzlThreeGrid, ffi::DzlThreeGridClass>) @extends gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_three_grid_get_type(),
    }
}

impl ThreeGrid {
    pub const NONE: Option<&'static ThreeGrid> = None;

    #[doc(alias = "dzl_three_grid_new")]
    pub fn new() -> ThreeGrid {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_three_grid_new()).unsafe_cast() }
    }
}

impl Default for ThreeGrid {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ThreeGrid>> Sealed for T {}
}

pub trait ThreeGridExt: IsA<ThreeGrid> + sealed::Sealed + 'static {
    #[doc(alias = "column-spacing")]
    fn column_spacing(&self) -> u32 {
        ObjectExt::property(self.as_ref(), "column-spacing")
    }

    #[doc(alias = "column-spacing")]
    fn set_column_spacing(&self, column_spacing: u32) {
        ObjectExt::set_property(self.as_ref(), "column-spacing", column_spacing)
    }

    #[doc(alias = "row-spacing")]
    fn row_spacing(&self) -> u32 {
        ObjectExt::property(self.as_ref(), "row-spacing")
    }

    #[doc(alias = "row-spacing")]
    fn set_row_spacing(&self, row_spacing: u32) {
        ObjectExt::set_property(self.as_ref(), "row-spacing", row_spacing)
    }

    #[doc(alias = "column-spacing")]
    fn connect_column_spacing_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_column_spacing_trampoline<
            P: IsA<ThreeGrid>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlThreeGrid,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ThreeGrid::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::column-spacing\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_column_spacing_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "row-spacing")]
    fn connect_row_spacing_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_row_spacing_trampoline<
            P: IsA<ThreeGrid>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlThreeGrid,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ThreeGrid::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::row-spacing\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_row_spacing_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<ThreeGrid>> ThreeGridExt for O {}

impl fmt::Display for ThreeGrid {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ThreeGrid")
    }
}
